from sqlalchemy import Table, Column, Integer, String
from sqlalchemy.ext.declarative import declarative_base

from toardb.base import Base

# controlled vocabulary

# Role Status
RS_enum_table = Table("rs_vocabulary",
                Base.metadata,
                Column("enum_val", Integer, primary_key=True),
                Column("enum_str", String),
                Column("enum_display_str", String)
          )
# The following code is just a workaround (see stationmeta/models.py):
from collections import namedtuple
Enumdict=namedtuple("Dict",["value","string","display_str"])
RS_enum = (
    Enumdict(0, 'active', 'active'),
    Enumdict(1, 'inactive', 'inactive'),
    Enumdict(2, 'unknown', 'unknown')
    )
 
# Role Codes
RC_enum_table = Table("rc_vocabulary",
                Base.metadata,
                Column("enum_val", Integer, primary_key=True),
                Column("enum_str", String),
                Column("enum_display_str", String)
          )
# The following code is just a workaround (see stationmeta/models.py):
RC_enum = (
    Enumdict(0, 'PointOfContact', 'point of contact'),
    Enumdict(1, 'PrincipalInvestigator', 'principal investigator'),
    Enumdict(2, 'Originator', 'originator'),
    Enumdict(3, 'Contributor', 'contributor'),
    Enumdict(4, 'Collaborator', 'collaborator'),
    Enumdict(5, 'ResourceProvider', 'resource provider')
    )

# Changelog: Type of Change
CL_enum_table = Table("cl_vocabulary",
                      Base.metadata,
                      Column("enum_val", Integer, primary_key=True),
                      Column("enum_str", String),
                      Column("enum_display_str", String)
                      )
# The following code is just a workaround (see stationmeta/models.py):
from collections import namedtuple
Enumdict=namedtuple("Dict",["value","string","display_str"])
CL_enum = (
    Enumdict(0, 'Created', 'created'),
    Enumdict(1, 'SingleValue', 'single value correction in metadata'),
    Enumdict(2, 'Comprehensive', 'comprehensive metadata revision'),
    Enumdict(3, 'Typo', 'typographic correction of metadata'),
    Enumdict(4, 'UnspecifiedData', 'unspecified data value corrections'),
    Enumdict(5, 'Replaced', 'replaced data with a new version'),
    Enumdict(6, 'Flagging', 'data value flagging')
    )

